; Si scriva un programma che segua le seguenti operazioni:
;  a. Riceva da tastiera due numeri positivi con valore massimo 10000
;  b. Se si tratta di numeri validi, ne esegua la media
;  c. Visualizzi il risultato a video
; n.b. acquisire un numero da tastiera significa riceverlo in caratteri ASCII,
; dopodich convertirlo tramite moltiplicazioni successive per 10.
; Ad esempio "123"  composto da 3 caratteri ASCII, '1', '2' e '3', per ottenere
; 123D occorre prima convertire le singole cifre (i.e. '1' -> 1D), poi eseguire
; il seguente calcolo -> (((1*10)+2)*10)+3.

				LEN EQU 6

.model small
.stack
.data
			
				MEDIA	 	dw 0
				MEDIA_STR	db LEN dup(0)
				NUMERO 	 	db LEN, 0, LEN dup(0)
				STRINGA1 	db 13, 10, "Inserire numero: $"
				STRINGA2 	db 13, 10, "Numero non valido!", 13, 10, '$'
				STRINGA3 	db 13, 10, "Media: $"

.code
.startup
			
				mov cx, 2
			
ciclo:			mov ah, 9
				lea dx, STRINGA1
				int 21h
				mov ah, 0ah
				lea dx, NUMERO
				int 21h
				sub sp, 2		; per il valore di ritorno
				call CHK_STRING
				pop ax			; se ax != 0, il numero presente e' valido e vale proprio ax
				cmp ax, 0
				jne next		; il numero  valido
				mov ah, 9
				lea dx, STRINGA2
				int 21h
				jmp ciclo
			
next:			add MEDIA, ax
				loop ciclo
				mov ax, MEDIA
				shr ax, 1		; divido per 2, faccio la media
				mov MEDIA, ax
				jmp stampa_media
			
CHK_STRING		proc near
			
				push bp
				mov bp, sp
				mov [bp+4], word ptr 0   ; azzero il valore di ritorno
				push ax
				push bx
				push cx
				push dx
				push si
			
				xor ax, ax
				mov bx, 10
				mov ch, 0
				mov cl, NUMERO[1]   ; cx contiene il numero di caratteri immessi
				mov si, 2			; si punta al primo carattere
				
				cmp cx, 1
				jnz get_num
				mov al, NUMERO[2]
				sub ax, '0'
				mov [bp+4], ax      ; aggiorno il valore di ritorno
				jmp cont
				
get_num:		mov al, NUMERO[si]
				sub ax, '0'
				mul bx
				dec cx
ripeti:			inc si
				mov dl, NUMERO[si] ; mettere dx e byte ptr
				sub dx, '0'
				add ax, dx
				xor dx, dx
				dec cx
				jz fine_num
				mul bx
				jmp ripeti

fine_num:		cmp ax,  10000
				ja cont 			; ax > 10000 quindi [bp+4], il valore di ritorno, rimane 0
				mov [bp+4], ax      ; aggiorno il valore di ritorno

cont:			pop si
				pop dx
				pop cx
				pop bx
				pop ax
				pop bp
				ret			
			
CHK_STRING 		endp
				
				; stampa media in esadecimale
stampa_media:	mov ah, 9
				lea dx, STRINGA3
				int 21h
				
				mov ch, 4 ; contatore
				mov cl, 12 ; numero shift ad ogni ciclo
				mov bx, MEDIA
				
ciclo2:			mov ax, bx
				and ax, 0f000h
				shr ax, cl
				add ax, '0'
				cmp ax, '9'
				jbe print_it
				add ax, 'A'-'0'-10
				
print_it:		mov dl, al
				mov ah, 2
				int 21h
				mov cl, 4
				rol bx, cl
				mov cl, 12
				dec ch
				jnz ciclo2
				
				mov dl, 'h'
				int 21h
				mov dl, ' '
				int 21h
				mov dl, '-'
				int 21h
				mov dl, '>'
				int 21h
				mov dl, ' '
				int 21h

				mov ax, MEDIA
				xor cx, cx  ; Quanti numeri visualizzo
				mov dx, 0
				mov bx, 10
				
ciclo3:			div bx	    ; ax = [dx,ax]/bx, dx = [dx,ax]%bx
				add dl, '0'
				push dx
				inc cx
				xor dx, dx
				cmp ax, 0
				jnz ciclo3
				
				mov ah, 2
stampa:			pop dx
				int 21h
				loop stampa
				
				mov dl, 'D'
				int 21h
				mov dl, 13
				int 21h
				mov dl, 10
				int 21h		
				
.exit
end
