;Si scriva un programma in linguaggio Assembler 8086 che esegua le seguenti operazioni:
;	a. Definisca due variabili VAR1 e VAR2 su 16 bit
;	b. Ne calcoli e memorizzi in VAR3 il massimo comune divisore utilizzando il metodo dei resti
;Codice C per metodo dei resti:
; 
; int N = 18, M = 12;
; int MCD;
; int MIN, MAX, RESTO;
; if (N<M) {
; 	MIN = N;
;	MAX = M;
; }
; else {
;	MIN = M;
;	MAX = N;
; }
; while(MIN!=0){
;	RESTO = MAX % MIN;
;	MAX = MIN;
;	MIN = RESTO;
; }
; MCD = MAX; //risultato MCD = 6
; Nota bene: si includa la funzione per il calcolo del MCD in una ipotetica libreria di funzioni matematiche, prestando attenzione a:
;	- riutilizzabilit della procedura
;	- struttura multi-file.

public calcola_mcd

.model small
.code

calcola_mcd proc
		
			push bp
			mov bp, sp
			sub sp, 6 ; variabili locali MIN, MAX e RESTO
			mov [bp-6], word ptr 0
			mov [bp-4], word ptr 0
			mov [bp-2], word ptr 0
			push ax
			push dx
			mov ax, [bp+4]
			cmp ax, [bp+6]
			jb min_bp_4     ; [bp+4]  il min
			mov [bp-4], ax	; [bp+4]  il max
			mov ax, [bp+6]  
			mov [bp-2], ax 
			jmp cont		
min_bp_4:	mov [bp-2], ax  ; [bp+4]  il min
			mov ax, [bp+6]
			mov [bp-4], ax

; MIN e' in [bp-2]

cont:		cmp [bp-2], word ptr 0
			jz next
			mov dx, 0
			mov ax, [bp-4]
			div word ptr [bp-2]
			; il resto e' in dx
			mov [bp-6], dx
			mov ax, [bp-2]
			mov [bp-4], ax ; MAX = MIN
			mov [bp-2], dx ; MIN = RESTO
			jmp cont

; imposto il valore di ritorno

next:		mov ax, [bp-4]
			mov [bp+8], ax ; RIS = MAX
		
			pop dx
			pop ax
			add sp, 6
			pop bp
			ret 4

calcola_mcd endp

end

