; Si scriva un programma in linguaggio ASM dellARM, lo si compili e se ne esegua il debug.
; Il programma deve:
; - inizializzare i registri R0-R7 dellARM con valori a piacimento
; - considerare coppie di registri adiacenti e confrontarli (R0 con R1, R2 con R3, ecc)
;      1. in caso siano uguali, ne calcoli il quadrato della somma
;      2. in caso siamo diversi, ne calcoli la media

                AREA    RESET, CODE, READONLY
                ENTRY
				
				ldr lr, =loop

				mov r0, #1
				mov r1, #2
				mov r2, #3
				ldr r3, =3
				mov r4, #4
				mov r5, #5
				mov r6, #5
				mov r7, #6
				mov r8, #0				

loop
				cmp r0, r1
				add r0, r0, r1
				muleq r9, r0, r0
				movne r9, r0, lsr #1
				
				cmp r2, r3
				add r2, r2, r3
				muleq r10, r2, r2
				movne r10, r2, lsr #1
				
				cmp r4, r5
				add r4, r4, r5
				muleq r11, r4, r4
				movne r11, r4, lsr #1

				cmp r6, r7
				add r6, r6, r7
				muleq r12, r6, r6
				movne r12, r6, lsr #1
				
				bx lr				

				end