; Si scriva un programma in linguaggio ASM dellARM, lo si compili e se ne esegua il debug.
; Il programma deve:
;  - inizializzare i registri R0-R1-R2 dellARM con valori a piacimento
;  - ordinare i valori, facendo in modo che alla fine R0 contenga il valore pi piccolo e
;    R2 quello pi grande
;  - una volta ordinato il vettore, stabilisca se i 2 numeri pi grandi sono multipli di
;    quello pi piccolo
;        1. in caso positivo, memorizzi in R4 il numero di volte per cui R1 contiene R0 e
;           in R5 il corrispondente per R2

        AREA    RESET, CODE, READONLY
        ENTRY

		mov r0, #2
		mov r1, #4
		mov r2, #7

		cmp r0, r1
		ble jump1	; r1 < r2

		; r1 > r2
jump4	cmp r1, r2
		ble jump3	; r2 < r3
	    b label6    ; ldr pc, =label6

jump3  	cmp r0, r2
		ble label4
		b label5

jump1	cmp r1, r2
		bge jump2
		b label1

jump2   cmp r0, r2
		ble label2
		b label3 

label1	b check_1

		; a, c, b
label2  mov r3, r1
		mov r1, r2
		mov r2, r3
		b fine

		; c, a, b
label3  mov r3, r0
		mov r4, r1
		mov r5, r2
		mov r0, r5
		mov r1, r3
		mov r2, r4
		b check_1

		; b, a, c
label4	mov r3, r0
		mov r0, r1
		mov r1, r3
		b check_1 
	    
		; b, c, a
label5  mov r3, r0
		mov r4, r1
		mov r5, r2
		mov r0, r4
		mov r1, r5
		mov r2, r3
		b check_1

		; c, b, a
label6	mov r3, r0
		mov r0, r2
		mov r2, r3		

check_1	mov r3, r1
loop1	subs r3, r3, r0
	    beq check_2
		bge loop1
		ldr r12, =0xffffffff
		b fine

check_2 mov r3, r2
loop2	subs r3, r3, r0
	    beq ok
		bge loop2
		ldr r12, =0xffffffff
		b fine

ok		ldr r12, =0xaaaaaaaa
fine
		END