; Si scriva un programma che esegua le seguenti operazioni:
;  a. Definisca un vettore VETT di 20 elementi di dimensione opportuna
;     per contenere i primi 20 numeri della serie di Fibonacci
;  b. Memorizzi in VETT la serie di Fibonacci in ordine invertito
;     (VETT[19] = 0, VETT[18] = 1, VETT[17] = 1, etc...)
;	 
; n.b. Si utilizzi il modo di indirizzamento indirect addressing e
; l'istruzione LOOP

		LEN equ 20

.model small
.stack
.data
	
		VETT dw 0,    1,   1,	2,   3,   5,   8,   13,   21,	34
			 dw 55,  89, 144, 233, 377, 610, 987, 1597, 2584, 4181
			 
.code
.startup

		mov  cx, LEN/2            ; numero di iterazioni
		lea  si, VETT			 ; puntatore al primo elemento
		lea  bx, VETT+(LEN*2)-2 	 ; puntatore all'ultimo elemento
		
ciclo: 	mov  ax, [bx]
		xchg ax, [si]
		mov  [bx], ax
		add	 si, 2
		sub  bx, 2
		LOOP ciclo
		
		.exit
		end
