; Si scriva un programma in linguaggio Assembler 8086 che esegua le seguenti operazioni:
;   a. Acquisisca da tastiera una stringa di caratteri
;   b. Controlli se la stringa acquisita  palindroma
;   c. Visualizzi a video un messaggio
;     i. che indichi se la stringa se  palindroma o meno
;     ii. nel caso non sia palindroma stampi a video la stringa invertita.

				LEN EQU 13

.model small
.stack
.data
		
				STRING	    db LEN DUP(0FFh)
				MESSAGGIO1  db "La stringa e' palindroma", 13, 10, '$' ; CR/LF
				MESSAGGIO2  db "La stringa non e' palindroma", 13, 10, '$'

.code
.startup
				lea dx, STRING
				mov byte ptr STRING, LEN-2
				mov ah, 0Ah
				int 21h
				sub sp, 2   ; per il valore di ritorno
				call CHECK_PAL
				pop ax		; in ax ho il valore di ritorno della funzione
				cmp ax, 0
				jz no_palindroma
				lea dx, MESSAGGIO1
				mov ah, 9
				int 21h
				jmp fine

no_palindroma:	lea dx, MESSAGGIO2
				mov ah, 9
				int 21h

				mov si, 2
				mov cl, byte ptr STRING[1]
				mov ch, 0
				add si, cx
				dec si		;si punta alla fine della stringa
				mov ah, 2
				
stampa:			mov dl, STRING[si]
				int 21h
				dec si
				loop stampa
				mov dl, 13
				int 21h
				mov dl, 10
				int 21h
				jmp fine

CHECK_PAL 		proc near

				push bp
				mov bp, sp
				mov [bp+4], word ptr 0
				push ax
				push bx
				push cx
				xor ax, ax
				xor bx, bx
				xor cx, cx
				mov si, 2		  ; si indice al primo elemento
				mov cl, byte ptr STRING[1] ; ho in cl il numero di caratteri immessi
				mov ch, 0
				add bx, 2
				add bx, cx
				dec bx    		  ; bx indice dell'ultimo carattere
				shr cx, 1         ; in cx ho il numero di iterazioni

ciclo:			mov al, STRING[si]
				cmp al, byte ptr STRING[bx]
				jnz exit
				inc si
				dec bx
				loop ciclo
				mov [bp+4], word ptr 1
exit:				
				pop cx
				pop bx
				pop ax
				pop bp
				ret

CHECK_PAL		endp

fine:			nop

.exit
end
