;Si scriva un programma che esegua un'operazione di filtraggio di una
;serie di segnali.
;	a. Si definiscano due vettori di elementi su 16 bit chiamati campioni
;	   e serie (si assuma che il numero di elementi sia compreso tra 1 e 100)
;	b. Eseguire un'operazione di filtraggio sul contenuto di campioni,
;	   corrispondente a calcolare per ciascun campione il valore medio di quello
;	   precedente, del successivo e del valore stesso.
;	c. Memorizzare gli n campioni dopo il filtraggio nel vettore serie.
;Si strutturi il programma in modo che l'operazione di filtraggio sia eseguita
;invocando una procedura chiamata filtro. Questa procedura restituisce al
;chiamante il valor medio di tutti gli elementi in campioni e deve sfruttare
;il meccanismo di passaggio parametri via STACK.
;Per il primo e l'ultimo campione si esegua la media su 2 valori

			LEN equ 6

.model small
.stack
.data

			CAMPIONI dw 5, 41, 27, 345, 9, 190
			SERIE	 dw LEN dup (0ffh)
		
.code
.startup

			lea dx, CAMPIONI
			mov cx, LEN
			mov si, 0
		
ciclo:		cmp si, 0
			jz confine_sx
			cmp si, 2*LEN-2
			jz confine_dx
			sub sp, 2 ; valore di ritorno
			push CAMPIONI[si-2]
			push CAMPIONI[si]
			push CAMPIONI[si+2]
			mov ax, 3
			push ax	  ; di quanti numeri devo calcolare la media
			call filtro
			jmp next
		
confine_sx:	sub sp, 2 ; valore di ritorno
			push CAMPIONI[si]
			push CAMPIONI[si+2]
			mov ax, 2
			push ax	  ; di quanti numeri devo calcolare la media
			call filtro
			jmp next
			
confine_dx:	sub sp, 2
			push CAMPIONI[si-2]
			push CAMPIONI[si]
			mov ax, 2
			push ax
			call filtro

next:		pop ax		; ho la media, presa dal valore di ritorno della funzione filtro
			mov SERIE[si], ax
			add si, 2
			loop ciclo
			jmp fine
			
filtro		proc near
			
			push bp
			mov bp, sp
			push ax
			push bx
			mov ax, [bp+4]  	; ax contiene quanti numero devo mediare (2 o 3)
			cmp ax, 2
			jz media_2
			
			mov ax, [bp+10]
			add ax, [bp+8]
			add ax, [bp+6]
			mov bl, 3
			div bl
			mov ah, 0			; in ax ho la media dei tre valori
			mov [bp+12], ax		; scrivo il risultato come valore di ritorno
			pop bx
			pop ax
			pop bp
			ret 8
			
media_2:	mov ax, [bp+8]
			add ax, [bp+6]
			shr ax, 1			; in ax ho la media dei due valori
			mov [bp+10], ax		; scrivo il risultato come valore di ritorno
			pop bx
			pop ax
			pop bp
			ret 6
			
filtro		endp

fine:		nop

.exit
end
