;Si scriva un programma in linguaggio Assembler 8086 che esegua le seguenti operazioni:
;	a. Definisca due variabili VAR1 e VAR2 su 16 bit
;	b. Ne calcoli e memorizzi in VAR3 il massimo comune divisore utilizzando il metodo dei resti
;Codice C per metodo dei resti:
; 
; int N = 18, M = 12;
; int MCD;
; int MIN, MAX, RESTO;
; if (N<M) {
; 	MIN = N;
;	MAX = M;
; }
; else {
;	MIN = M;
;	MAX = N;
; }
; while(MIN!=0){
;	RESTO = MAX % MIN;
;	MAX = MIN;
;	MIN = RESTO;
; }
; MCD = MAX; //risultato MCD = 6
;Nota bene: si includa la funzione per il calcolo del MCD in una ipotetica libreria di funzioni matematiche, prestando attenzione a:
;	- riutilizzabilit della procedura
;	- struttura multi-file.

extrn calcola_mcd:near

.model small
.stack
.data

	VAR1 dw 18
	VAR2 dw 12
	VAR3 dw ?

.code
.startup
	
	lea dx, VAR1
	sub sp, 2
	mov ax, VAR2
	push ax
	mov ax, VAR1
	push ax
	call calcola_mcd
	pop ax
	mov VAR3, ax

.exit
end
