; Si scriva un programma che acquisisca dalla porta B dell8255 un valore
; sotto forma e stabilisca se questo  pari o dispari;
; in caso sia pari, si emetta sulla porta A il valore 0H,
; altrimenti il valore 0FFH.
#start=8255.exe#

.model small          
.data        
.stack     
.code   
        
			; procedura di inizializzazione della interrupt vector table
INIT_IVT	proc
			push ax
			push bx
			push dx
			push ds
			xor	ax, ax
			mov	ds, ax      
		
			; channel 7
			mov	bx, 39		
			shl	bx, 2		
			mov ax, offset ISR_PA_IN
			mov	ds:[bx], ax
			mov	ax, seg ISR_PA_IN
			mov	ds:[bx+2], ax       
			; channel 6
			mov	bx, 38		
			shl	bx, 2		
			mov ax, offset ISR_PA_OUT
			mov	ds:[bx], ax
			mov	ax, seg ISR_PA_OUT
			mov	ds:[bx+2], ax       		
			; channel 5
			mov	bx, 37		
			shl	bx, 2		
			mov ax, offset ISR_PB_IN
			mov	ds:[bx], ax
			mov	ax, seg ISR_PB_IN
			mov	ds:[bx+2], 	AX       				
			; channel 4
			mov	bx, 36		
			shl	bx, 2		
			mov ax, offset ISR_PB_OUT
			mov	ds:[bx], ax
			mov	ax, seg ISR_PB_OUT
			mov	ds:[bx+2], ax       		
					
			pop	ds
			pop	dx
			pop	bx
			pop	ax
			ret
INIT_IVT	endp

INIT_8255	proc
			mov al, 10000110b         
			out 083h, al
			mov al, 00000101b    
			out 083h, al   
			ret
INIT_8255   endp        

; ISR for reading the value received on PA            
ISR_PA_IN   proc                
            iret    
ISR_PA_IN   endp             
              
; ISR for waiting a confirmation that the value written on PA is externally read 
ISR_PA_OUT  proc               
            iret    
ISR_PA_OUT  endp                                  
                           
; ISR for reading the value received on PB                                       
ISR_PB_IN   proc              
            in al, 081h
            shr al, 1
            jc is_dispari
            mov al, 0
            out 080h, al
            jmp fine
is_dispari: mov al, 0ffh
            out 080h, al
fine:		sti
            iret    
ISR_PB_IN   endp             
                                          
; ISR for waiting a confirmation that the value written on PB is externally read                                           
ISR_PB_OUT  proc
            
            iret    
ISR_PB_OUT  endp         
            
    
.startup    
		cli         
		call INIT_IVT
		call INIT_8255
		sti            
              
next:	nop         
		;hlt
		jmp next
          
.exit
end
