#ifndef _SEMAPHORE_H_
#define _SEMAPHORE_H_

typedef void SigFunc (int);

int set_handler (int, SigFunc);

int sem_create(int[2]);

int sem_wait(int[2]);

int sem_post(int[2]);

int sem_init(int[2], int);

/* ritorna 0 se e' scaduto il timeout,
   1 se la wait va a buon fine,
   -1 in caso di errore*/
int sem_trywait(int[2], int);

#endif