#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <sys/types.h>
#include <signal.h>
#include <pthread.h>

static void * sender();
static void * receiver();
void catcher();

pthread_t receiver_th, sender_th;
char line[132]; 
int sent_msg; 

int main ()
{
  void *retval;

  signal(SIGUSR1,catcher);

  pthread_create (&receiver_th, NULL, receiver, NULL);
  pthread_create (&sender_th, NULL, sender, NULL);

  pthread_join (receiver_th, &retval);
  pthread_join (sender_th, &retval);

  printf("Sent Messsages %d\n", sent_msg);

  return (1);
}

void catcher()
{
  signal(SIGUSR1, catcher);  
}

static void * sender ()
{
  while (1)
  {
    printf("String (stop with end): ");
    if (fgets (line, sizeof (line), stdin) == NULL)
	exit (1);
    sent_msg++;  
    pthread_kill(receiver_th, SIGUSR1);
    if (strcmp(line, "end\n") == 0)
	break;
    pause();   // wait a signal from the receiver
    printf("Converted String      : %s", line);
  }
  return 0; 
}

static void * receiver ()
{
  int i;
  while(1)
  {
    pause();
    if (strcmp(line, "end\n") == 0)
	break;
    for(i=0;i<strlen(line);i++)
	line[i]= toupper(line[i]);
    pthread_kill(sender_th, SIGUSR1);
  }
  return 0; 
}


