CREATE OR REPLACE TRIGGER acc_2_sales
AFTER UPDATE ON DIP 
FOR EACH ROW
WHEN (OLD.DNAME = 'ACCOUNTING' AND NEW.DNAME = 'SALES')
BEGIN
UPDATE IMP
SET SAL=SAL+100
WHERE DEPTNO = :NEW.DEPTNO;
END;

SELECT EMPNO, SAL
FROM IMP
WHERE DEPTNO = 10
ORDER BY EMPNO;

SELECT *
FROM DIP;

SELECT EMPNO, DNAME, SAL
FROM EMP, DIP
WHERE EMP.DEPTNO = DIP.DEPTNO AND DIP.DEPTNO = 10
ORDER BY EMPNO;

select trigger_name, triggering_event, table_name,
status, description, action_type, trigger_body
from user_triggers;

UPDATE DIP set DNAME = 'SALES' where DNAME='ACCOUNTING';