
REMARK
/*
Trigger INS_ROW
*/

create trigger INS_ROW
after insert on imp
for each row
when (NEW.job = 'CLERK')
begin
insert into copy_clerk values (:NEW.empno, :NEW.ename, :NEW.sal);
end;
/ 




REMARK
/*
Trigger UP_IMP
*/
create trigger UP_IMP
after UPDATE of empno, sal, job, ename on imp 
for each row
begin
if ((:NEW.job = 'CLERK') and (:OLD.JOB != 'CLERK')) then
INSERT into copy_clerk values (:NEW.empno, :NEW.ename, :NEW.sal);
end if; 


if ((:OLD.job = 'CLERK') and (:NEW.JOB != 'CLERK')) then
delete from copy_clerk where empno=:OLD.empno;
end if;


if ((:OLD.job = 'CLERK') and (:NEW.JOB = 'CLERK')) then
UPDATE copy_clerk set ename=:NEW.ename, empno=:NEW.empno, sal=:NEW.sal where empno=:OLD.empno;
end if;

end;
/ 











